#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct PsdNode {
    #[builder(custom(type = super::NumericSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeriesNode>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::api::StftOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "stftOptions", skip_serializing_if = "Option::is_none", default)]
    stft_options: Option<Box<super::super::super::api::StftOptions>>,
    #[builder(default, into)]
    #[serde(
        rename = "magnitudeScaling",
        skip_serializing_if = "Option::is_none",
        default
    )]
    magnitude_scaling: Option<super::super::super::api::MagnitudeScaling>,
    #[builder(default, into)]
    #[serde(
        rename = "outputFrequencyType",
        skip_serializing_if = "Option::is_none",
        default
    )]
    output_frequency_type: Option<super::super::super::api::OutputFrequencyType>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::api::FrequencySummarizationStrategy>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "summarizationStrategy",
        skip_serializing_if = "Option::is_none",
        default
    )]
    summarization_strategy: Option<
        Box<super::super::super::api::FrequencySummarizationStrategy>,
    >,
}
impl PsdNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::NumericSeriesNode) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn stft_options(&self) -> Option<&super::super::super::api::StftOptions> {
        self.stft_options.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn magnitude_scaling(
        &self,
    ) -> Option<&super::super::super::api::MagnitudeScaling> {
        self.magnitude_scaling.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn output_frequency_type(
        &self,
    ) -> Option<&super::super::super::api::OutputFrequencyType> {
        self.output_frequency_type.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn summarization_strategy(
        &self,
    ) -> Option<&super::super::super::api::FrequencySummarizationStrategy> {
        self.summarization_strategy.as_ref().map(|o| &**o)
    }
}
